<?php

// $Id: visitors.pages.inc,v 1.2 2009/04/23 21:10:08 gashev Exp $

/**
 * Implementation of hook_node().
 */
function visitors_node() {
	if ($node = node_load(arg(1))) {
	    $date_format = variable_get('date_format_short_custom', 'Y-m-d H:i:s');
	    $items_per_page = variable_get('default_nodes_main', 10);
	
	    $header = array(
					    array('data' => t('#')),
					    array('data' => t('ID'), 'field' => 'visitors_id', 'sort' => 'desc'), 
					    array('data' => t('Date'), 'field' => 'visitors_date_time'), 
					    array('data' => t('Referrer'), 'field' => 'visitors_referer'), 
					    array('data' => t('User'), 'field' => 'u.name'), 
					    array('data' => t('Operations'))
					    );

	    $sql = sprintf("SELECT v.*, u.name, u.uid 
                        FROM {visitors} v 
                        LEFT JOIN {users} u 
                        ON u.uid = v.visitors_uid 
                        WHERE v.visitors_path LIKE 'node/%d%%'". 
                        tablesort_sql($header),
                        $node->nid);

	    $sql_count = sprintf("SELECT v.*, u.name, u.uid 
                                FROM {visitors} v 
                                LEFT JOIN {users} u 
                                ON u.uid = v.visitors_uid 
                                WHERE v.visitors_path LIKE 'node/%d%%'", 
                                $node->nid);
                                
      $query = db_query($sql_count);
      $data = db_fetch_object($query);

	    $results = pager_query($sql, $items_per_page, 0, $sql_count);

	    $rows = array();

	    $page = isset($_GET['page']) ? $_GET['page'] : '';
	    $i = 0 + ($page  * $items_per_page);

	    while ( $data = db_fetch_object($results) ) 
	    {
		    $user = user_load(array('uid' => $data->visitors_uid));
		    $user_page = theme('username', $data);
		    $rows[] = array(
			    ++$i,
			    $data->visitors_id,
			    date($date_format, $data->visitors_date_time),
			    l($data->visitors_referer, $data->visitors_referer),
			    $user_page,
                l(t('details'), 'admin/visitors/hits/'.$data->visitors_id)
		    );
	    }

	    $output  = "";
	    $output .= theme('table', $header, $rows);
	    $output .= theme('pager', NULL, $items_per_page, 0);
	    drupal_set_title($node->title);
        
	    return $output;
	}
}
